<!DOCTYPE html>
<html lang ="en">
    <head>
        <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <!-- The above 3 meta tags *must* come first in the head; any other head content must come *after* these tags -->
    <meta name="description" content="">
    <meta name="author" content="">
    <link rel="icon" href="../../favicon.ico">

    <title>PHUONG NGUYEN - Assignment #11</title>
    <script type='text/javascript' src="/jquery/jquery.js"></script>
    <!-- Bootstrap core CSS -->
    <link href="https://getbootstrap.com/docs/3.3/dist/css/bootstrap.min.css" rel="stylesheet">

    <!-- IE10 viewport hack for Surface/desktop Windows 8 bug -->
    <link href="https://getbootstrap.com/docs/3.3/assets/css/ie10-viewport-bug-workaround.css" rel="stylesheet">

    <!-- Custom styles for this template -->
    <link href="https://getbootstrap.com/docs/3.3/examples/starter-template/starter-template.css" rel="stylesheet">
    </head> 
    <body>
        <nav class="navbar navbar-inverse navbar-fixed-top">
      <div class="container">
        <div class="navbar-header">
          <button type="button" class="navbar-toggle collapsed" data-toggle="collapse" data-target="#navbar" aria-expanded="false" aria-controls="navbar">
            <span class="sr-only">Toggle navigation</span>
            <span class="icon-bar"></span>
            <span class="icon-bar"></span>
            <span class="icon-bar"></span>
          </button>
          <a class="navbar-brand">Phuong Nguyen - Assignment #11: Ajax and jQuery</a>
        </div>
      </div>
    </nav>

    <div class="container">
      <div class="starter-template">
        <h1><%= title %></h1> 
          <div class="row">
        <div class="col-sm-2">
          Type of data: 
        </div>
        <div class="col-sm-3">
          <div class="form-inline">
            <input type="radio" name="typeofitem" value="books" class="form-control">&nbsp;Books
            <input type="radio" name="typeofitem" value="donuts" class="form-control">&nbsp;Donuts&nbsp;&nbsp;
          </div>
        </div>        
      </div>
      <div class="row">
        <div class="col-sm-2">
          Type of style: 
        </div>
        <div class="col-sm-3">
          <div class="form-inline">
            <input type="radio" name="typeofstyle" value="raw" class="form-control">&nbsp;Raw&nbsp;&nbsp;
            <input type="radio" name="typeofstyle" value="formatted" class="form-control">&nbsp;Formatted
          </div>
        </div>        
      </div>
      <div class="row">
        <div class="col-sm-2">
          Type of file: 
        </div>
        <div class="col-sm-3">
          <div class="form-inline">
            <input type="radio" name="typeofformat" value="xml" class="form-control">&nbsp;XML&nbsp;&nbsp;
            <input type="radio" name="typeofformat" value="json" class="form-control">&nbsp;JSON
          </div>
        </div>        
      </div>
      <div class="row">
        <div class="col-sm-2">
          <input type="button" class="btn btn-primary" name="submit" value="Submit" onclick="check()" />
        </div>
      </div>
      </div>
       <xmp class="row" id="result">
      </xmp>
    </div><!-- /.container -->
    
    <table class="table hidden" id="donutsxml">
      <tr>
        <th>Type</th>
        <th>Name</th>
        <th>PPU</th>
        <th>Batters</th>
        <th>Topping</th>
        <th>Fillings</th>
      </tr>
    </table>    
    <table class="table hidden" id="booksxml">
      <tr>
        <th>ID</th>
        <th>Author</th>
        <th>Title</th>
        <th>Genre</th>
        <th>Price</th>
        <th>Publish Date</th>
        <th>Description</th>
      </tr>
    </table>
    <table class="table hidden" id="donutsjson">
      <tr>
        <th>Type</th>
        <th>Name</th>
        <th>PPU</th>       
        <th>Batters</th>
        <th>Topping</th>
        <th>Fillings</th>
      </tr>
    </table>
    <table class="table hidden" id="booksjson">
      <tr>
        <th>ID</th>
        <th>Author</th>
        <th>Title</th>
        <th>Genre</th>
        <th>Price</th>
        <th>Publish Date</th>
        <th>Description</th>
      </tr>
    </table>
    </body>
    
<script type="text/javascript">
        function check(){
        var item=$("input[name='typeofitem']:checked").val(),
          style=$("input[name='typeofstyle']:checked").val(),
          format=$("input[name='typeofformat']:checked").val();
        if(format=="xml"){
          if(style=="raw"){
            if(item=="donuts"){
              console.log("raw donuts.xml");
              $("#result").load("donuts.xml");
              $("#result").removeClass('hidden');
              $("#donutsxml").addClass('hidden');
              $("#booksxml").addClass('hidden');
              $("#donutsjson").addClass('hidden');
              $("#booksjson").addClass('hidden');
            }else{
              console.log("raw books.xml");
              $("#result").load("books.xml");
              $("#result").removeClass('hidden');
              $("#donutsxml").addClass('hidden');
              $("#booksxml").addClass('hidden');
              $("#donutsjson").addClass('hidden');
              $("#booksjson").addClass('hidden');
            }
          }else{
            if(item=="donuts"){
              console.log("formatted donuts.xml");
              $.ajax({
                url: "donuts.xml",
                dataType: "xml",
                success: function(data){
                  var txt = "";
                  $(data).find('item').each(function(){
                    var type = $(this).find('type').text();
                    var name = $(this).children('name').text();
                    var ppu = $(this).find('ppu').text();
                    txt += "<tr><td>"+type+"</td><td>"+name+"</td><td>"+ppu+"</td>";
                    txt += "<td>";
                    $(this).find('batter').each(function(){
                      var t1 = $(this).find('text').text();
                      txt += t1+"</br>";
                    });
                    txt += "</td>";
                    txt += "<td>";
                    $(this).find('topping').each(function(){
                      var t2 = $(this).find('text').text();
                      txt += t2+"</br>";
                    });
                    txt += "</td>";
                    txt += "<td>";
                    $(this).find('filling').each(function(){
                      var t3 = $(this).children('name').text();
                      var t4 = $(this).find('addcost').text();
                      txt += t3+"&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"+t4+"</br>";
                    });
                    txt += "</td></tr>";
                  });
                  console.log(txt);
                  $('#donutsxml tr:gt(0)').remove()
                  $("#donutsxml").append(txt);
                  $("#donutsxml").removeClass('hidden');
                  $("#booksxml").addClass('hidden');
                  $("#donutsjson").addClass('hidden');
                  $("#booksjson").addClass('hidden');
                  $("#result").addClass('hidden');
                },
                error: function() {
                  alert("An error occurred while processing XML file.");
                }
              });
            }else{
              console.log("formatted books.xml");
              $.ajax({
                url: "books.xml",
                dataType: "xml",
                success: function(data){
                  //console.log($(data));
                  var txt = "";
                  $(data).find('book').each(function(){
                    var id = $(this).attr('id');
                    var title = $(this).find('title').text();
                    var author = $(this).find('author').text();
                    var genre = $(this).find('genre').text();
                    var publish_date = $(this).find('publish_date').text();
                    var price = $(this).find('price').text();
                    var description = $(this).find('description').text();                   
                    txt += "<tr><td>"+id+"</td><td>"+author+"</td><td>"+title+"</td><td>"+genre+"</td><td>"+price+"</td><td>"+publish_date+"</td><td>"+description+"</td></tr>";
                  });
                  $('#booksxml tr:gt(0)').remove()
                  $("#booksxml").append(txt);
                  $("#booksxml").removeClass('hidden');
                  $("#donutsxml").addClass('hidden');                 
                  $("#donutsjson").addClass('hidden');
                  $("#booksjson").addClass('hidden');
                  $("#result").addClass('hidden');
                },
                error: function() {
                  alert("An error occurred while processing XML file.");
                }
              });
            }
          }
        }else{
          if(style=="raw"){
            $("#result").empty();
            if(item=="donuts"){
              console.log("raw donuts.json");
              $.ajax({
                url: "donuts.json",
                dataType: "json",
                success: function(data){
                  console.log(data);
                  $("#result").append(JSON.stringify(data, undefined, 2));
                  $("#result").removeClass('hidden');
                  $("#donutsxml").addClass('hidden');
                  $("#booksxml").addClass('hidden');
                  $("#donutsjson").addClass('hidden');
                  $("#booksjson").addClass('hidden');
                },
                error: function() {
                  alert("An error occurred while processing JSON file.");
                }
              });
            }else{
              console.log("raw books.json");
              $.ajax({
                url: "books.json",
                dataType: "json",
                success: function(data){
                  console.log($(data));
                  $("#result").append(JSON.stringify(data, undefined, 2));
                  $("#result").removeClass('hidden');
                  $("#donutsxml").addClass('hidden');
                  $("#booksxml").addClass('hidden');
                  $("#donutsjson").addClass('hidden');
                  $("#booksjson").addClass('hidden');
                },
                error: function() {
                  alert("An error occurred while processing JSON file.");
                }
              });
            }
          }else{
            if(item=="donuts"){
              console.log("formatted donuts.json");
              $.ajax({
                url: "donuts.json",
                dataType: "json",
                success: function(data){                  
                  var len = data.items.item.length;
                  var txt = "";
                  for(var i=0;i<len;i++){
                    txt += "<tr><td>"+data.items.item[i].type+"</td><td>"+data.items.item[i].name+"</td><td>"+data.items.item[i].ppu+"</td>";
                    var len1= data.items.item[i].batters.batter.length;
                    txt += "<td><table>"
                    for(var j=0;j<len1;j++){
                      txt += "<tr><td>"+data.items.item[i].batters.batter[j].text+"</td></tr>";
                    }
                    txt += "</table></td>";
                    if(data.items.item[i].topping != undefined){
                      var len1= data.items.item[i].topping.length;
                      txt += "<td><table>";
                      for(var j=0;j<len1;j++){
                        txt += "<tr><td>"+data.items.item[i].topping[j].text+"</td></tr>";
                      }
                      txt += "</table></td>";
                    }
                    if(data.items.item[i].fillings != undefined){
                      var len1= data.items.item[i].fillings.filling.length;
                      txt += "<td><table>"
                      for(var j=0;j<len1;j++){
                        txt += "<tr><td>"+data.items.item[i].fillings.filling[j].name+"</td><td>&nbsp;&nbsp;&nbsp;&nbsp;"+data.items.item[i].fillings.filling[j].addcost+"</tr>";
                      }
                      txt += "</table></td>";
                    }
                  }
                  txt += "</tr>";
                  $('#donutsjson tr:gt(0)').remove();
                  $("#donutsjson").append(txt);
                  $("#donutsjson").removeClass('hidden');
                  $("#donutsxml").addClass('hidden');
                  $("#booksxml").addClass('hidden');                  
                  $("#booksjson").addClass('hidden');
                  $("#result").addClass('hidden');
                  
                },
                error: function() {
                  alert("An error occurred while processing JSON file.");
                }
              });
            }else{
              console.log("formatted books.json");
              $.ajax({
                url: "books.json",
                dataType: "json",
                success: function(data){
                  console.log(data);
                  var len = data.catalog.book.length;
                  var txt = "";
                  for(var i=0;i<len;i++){
                    txt += "<tr><td>"+data.catalog.book[i].id+"</td><td>"+data.catalog.book[i].author+"</td><td>"+data.catalog.book[i].title+"</td><td>"+data.catalog.book[i].genre+"</td><td>"+data.catalog.book[i].price+"</td><td>"+data.catalog.book[i].publish_date+"</td><td>"+data.catalog.book[i].description+"</td></tr>";
                  }
                  $('#booksjson tr:gt(0)').remove();
                  $("#booksjson").append(txt);
                  $("#booksjson").removeClass('hidden');
                  $("#donutsxml").addClass('hidden');
                  $("#booksxml").addClass('hidden');
                  $("#donutsjson").addClass('hidden');
                  $("#result").addClass('hidden');
                },
                error: function() {
                  alert("An error occurred while processing JSON file.");
                }
              });
            }
          }
        }
      }



    </script>
</html>
